/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTK
#ifndef GTK_TRICK_HEADER
#define GTK_TRICK_HEADER

class Trick;
class Player;

namespace GTK_DOKO {

  class Trick {
    public:
      // constructor -- set the table
      Trick(class Table* table_a);

      // initializes the trick
      void init();

      // the variables
      class GTK_GUI& gui(); // the gui
      class Table& table(); // the table

      // starting x-position of the card of player
      int card_start_x(Player const& player);
      // starting y-position of the card of player
      int card_start_y(Player const& player);
      // starting x-position of the trick
      int start_x();
      // starting y-position of the trick
      int start_y();
      // width of the trick
      unsigned width();
      // height of the trick
      unsigned height();

      // draws the trick
      void draw(::Trick const& trick, bool const update = true);

      // updates the language
      void language_update();

    private:
      class Table* const table_p; // the table, this trick belongs to

    private: // not to be used
      Trick();
      Trick(Trick const&);
      Trick& operator=(Trick const&);
  }; // class Trick

} // namspace GTK_DOKO
#endif // #ifndef GTK_TRICK_HEADER
#endif // #ifdef USE_UI_GTK
